package	jp.co.sds_corp.hibiya.adapter;

import java.util.List;
import java.util.Vector;

import jp.co.sds_corp.hibiya.server.IChecker;
import jp.co.sds_corp.util.config.IConfiguration;
import jp.co.sds_corp.util.daemon.IInitializer;
import jp.co.sds_corp.util.daemon.config.ConfigUtility;

/**
* {@link IAdapter}のインスタンスを管理します。
*/
public class AdapterFactory implements IInitializer
{
	IAdapter adapter;
	private static Vector<IAdapter> vecAdapter = new Vector<IAdapter>();

	/**
	* 設定情報で初期化します。
	* @param	config	設定情報
	*/
	public void init( IConfiguration config ) throws Exception {
		IConfiguration c = config.getChild( "Adapter" );
		adapter = (IAdapter )ConfigUtility.createInstance( c );
		adapter.init( c );
		vecAdapter.add( adapter );
	}

	public void start() {
		adapter.start();
	}

	public void stop() {
		adapter.stop();
	}

	public static void setStarted( boolean var ) {
		for ( int i = 0; i < vecAdapter.size(); i++ ) {
			IAdapter adapter = (IAdapter )vecAdapter.get( i );
			adapter.setStarted( var );
		}
	}

	public static void addChecker( IChecker chk ) {
		for ( int i = 0; i < vecAdapter.size(); i++ ) {
			IAdapter adapter = (IAdapter )vecAdapter.get( i );
			adapter.addChecker( chk );
		}
	}

	public static void removeChecker( IChecker chk ) {
		for ( int i = 0; i < vecAdapter.size(); i++ ) {
			IAdapter adapter = (IAdapter )vecAdapter.get( i );
			adapter.removeChecker( chk );
		}
	}

	public static List<IAdapter> listAdapter() {
		return vecAdapter;
	}
}
